package com.liang.service;

import com.liang.entity.PrjDivisioncompany;
import com.liang.entity.PrjSubtopicplan;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;

/**
 * (PrjSubtopicplan)表服务接口
 *
 * @author makejava
 * @since 2023-04-05 09:15:19
 */
public interface PrjSubtopicplanService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjSubtopicplan queryById(Integer id);

    /**
     * 分页查询
     *
     * @param prjSubtopicplan 筛选条件
     * @param pageRequest     分页对象
     * @return 查询结果
     */
    Page<PrjSubtopicplan> queryByPage(PrjSubtopicplan prjSubtopicplan, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param prjSubtopicplan 实例对象
     * @return 实例对象
     */
    PrjSubtopicplan insert(PrjSubtopicplan prjSubtopicplan);

    /**
     * 修改数据
     *
     * @param prjSubtopicplan 实例对象
     * @return 实例对象
     */
    PrjSubtopicplan update(PrjSubtopicplan prjSubtopicplan);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 获取子课题计划
     *
     * @param zkt
     * @return
     */
    List<PrjSubtopicplan> getSubtopicPlanList(Integer zkt);

    /**
     * 通过子课题删除数据
     *
     * @param zkt
     * @return
     */
    int deleteByZkt(Integer zkt);

    /**
     * 批量删除子课题单位分工
     *
     * @param zktList
     * @return
     */
    int batchDeleteByZkt(List<Integer> zktList);

    /**
     * 批量插入子课题计划
     *
     * @param planList
     * @return
     */
    int insertBatch(@Param("entities") List<PrjSubtopicplan> planList);
}
